## 一些比较有意思的公式

### 中心向外旋转扩散

```kotlin
val originalX = distance * progress
val originalY = 0.01 * sqrt(originalX) * (originalX - distance)
val x = originalX * cos - originalY * sin
val y = originalX * sin + originalY * cos
return Pair(x.toInt(), y.toInt())
```

### 中心向外扩散后往中心聚拢

```kotlin
val originalX = distance * progress
val originalY = 0.01 * originalX * (originalX - distance)
val x = originalX * cos - originalY * sin
val y = originalX * sin + originalY * cos
return Pair(x.toInt(), y.toInt())
```

### 正弦弹性

```kotlin
val originalX = distance * progress
val originalY = 100 * sin(originalX / 50)
val x = originalX * cos - originalY * sin
val y = originalX * sin + originalY * cos
return Pair(x.toInt(), y.toInt())
```

### 心形线

```kotlin
val t = distance * progress
val x =  16 * sin(t).pow(3)
val y = 13 * cos(t) - 5 * cos(2 * t) - 2 * cos(3 * t) - cos(4 * t)
return Pair(30 * x.toInt(), 30 * y.toInt())
```

### 一些说不出名字的效果(重点在把 original 坐标和变换后坐标混用)

#### 柱形

```kotlin
val originalX = distance * progress
val originalY = 100 * sin(originalX / 50)
val x = originalX * cos - originalY * sin
val y = originalX * sin + originalY * cos
return Pair(originalY.toInt(), x.toInt())
```

#### 波浪上浮

```kotlin
val originalX = distance * progress
val originalY = 100 * sin(originalX / 50)
val x = originalX * cos - originalY * sin
val y = originalX * sin + originalY * cos
return Pair(y.toInt(), -originalX.toInt())
```

#### 柱形展开

```kotlin
val originalX = distance * progress
val originalY = 100 * sin(originalX / 50)
val x = originalX * cos - originalY * sin
val y = originalX * sin + originalY * cos
return Pair((0.008 * y * originalX).toInt(), (0.01 * x * originalY).toInt())
```

#### 动感 DJ 

```kotlin
val originalX = distance * progress
val originalY = 100 * sin(originalX / 50)
val x = originalX * cos - originalY * sin
val y = originalX * sin + originalY * cos
return Pair((0.01 * x * originalY).toInt(), -(0.0001 * y.pow(2) * originalX).toInt())
```

### 以上基于随机 sin 和 cos 值。如果改为基于极坐标的 theta 正余弦值，同样有酷炫效果

### 以下是基于极坐标的公式：

#### 圆圈中心向外螺旋扩散

```kotlin
val originalX = distance * progress
val originalY = 60
val x = originalX * cos(theta) - originalY * sin(theta)
val y = originalX * sin(theta) + originalY * cos(theta)
return Pair(x.toInt(), y.toInt())
```

